Bug 1270554 - (haxe) Review Request: haxe - Multi-target universal programming language
Review Request: haxe - Multi-target universal programming language
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Miroslav Suchý
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-11 00:49 EDT by Andy Li
Modified: 2015-11-15 22:22 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-15 22:22:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
msuchy: fedora‑review+


Attachments (Terms of Use)
licensecheck.txt (120.88 KB, text/plain)
2015-10-12 15:32 EDT, Raphael Groner
no flags Details

  None (edit)
Description Andy Li 2015-10-11 00:49:52 EDT
Spec URL: https://build.opensuse.org/package/view_file/home:onthewings/haxe/haxe.spec?expand=1
SRPM URL: http://download.opensuse.org/repositories/home:/onthewings/Fedora_22/src/haxe-3.2.0-3.1.src.rpm
Description: Multi-target universal programming language
Fedora Account System Username: andyli

Hi,

This is Andy from the Haxe Foundation. I would like to submit the haxe package to Fedora.
I'm using the openSUSE build system. The source files and the built rpms can be found at https://build.opensuse.org/package/show/home:onthewings/haxe
The package depends on the nekovm package, which has been submitted by a volunteer (https://bugzilla.redhat.com/show_bug.cgi?id=460779). I also plan to clean up and improve the nekovm package later.

Best regards,
Andy
Comment 1 Raphael Groner 2015-10-11 16:16:50 EDT
Please use a valid Spec URL that gives raw content, fedora-review is not able to read html formatted pages, therefore you can ask for some space at fedorapeople.org .

Otherwise, I am interested in doing the official review.
Comment 2 Andy Li 2015-10-11 21:16:18 EDT
The url to the raw spec is https://build.opensuse.org/source/home:onthewings/haxe/haxe.spec

Hope it works for you.

Best regards,
Andy
Comment 3 Raphael Groner 2015-10-12 05:19:21 EDT
# The source of this package was pulled from upstreams's vcs.
# It is because the Github-created tar does not inslude submodules.
- You may use Source0: and Source1: (value is accessible respectively as %{SOURCE1}) for both individual tar downloads. Arrange the files in %prep after untar with %setup0 and %setup1 or use directly the tar command.

- Please remove the now obsolete Group: and Buildroot: tags.

# https://github.com/HaxeFoundation/ocamllibs/pull/19
Patch0:         haxe-libs-license.patch
- It's okay to ask upstream and suggest a patch. But please remove it from the package, license is completely a thing of upstream and shouldn't be modified at all in Fedora.

%install
rm -rf %{buildroot}
- You can remove the rm line, it's useless.

- Use cp -p to preserve timestamps.

%files
%defattr(-,root,root,-)
- Please remove %defattr, it's not needed.
Comment 4 Andy Li 2015-10-12 11:02:29 EDT
Thanks for the review.
Here are the updated files revised according to your comment:

Spec URL: https://build.opensuse.org/source/home:onthewings/haxe/haxe.spec
SRPM URL: http://download.opensuse.org/repositories/home:/onthewings/Fedora_22/src/haxe-3.2.0-9.1.src.rpm
Comment 5 Raphael Groner 2015-10-12 15:29:48 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines
- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
- Please verify License: tag, there are files with LGPL, GPL (in different
  versions), BSD and MIT.
- Correct the name of SRPM (and link), weird/wrong Release there?
- Is it possible to have some development files in a devel subpackage?
- Version 3.2.1 is available at upstream, please update.
- Use a data sub package for the large content in /usr/share/haxe/ .
- Fix at least all errors of rpmlint (optionally plus warnings), see below.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[?]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later) (with incorrect FSF address)", "Unknown
     or generated", "MIT/X11 (BSD like)", "*No copyright* LGPL (v2.1 or
     later) (with incorrect FSF address)", "zlib/libpng", "BSD (3 clause)",
     "GPL (unversioned/unknown version)", "GPL (v2 or later) (with
     incorrect FSF address)", "BSD (2 clause)", "LGPL (v2.1 or later)",
     "*No copyright* MIT/X11 (BSD like)". 2086 files have unknown license.
     Detailed output of licensecheck in /home/builder/fedora-
     review/1270554-haxe/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
=> # note that the Makefile does not support parallel building
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[?]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Uses parallel make %{?_smp_mflags} macro.
=> Okay, see comment.
[?]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[?]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in haxe-
     debuginfo
=> I do not understand. Ignore for now.
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
=> Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11418047
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 5376000 bytes in /usr/share


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/builder/fedora-review/1270554-haxe/results/haxe-3.2.0-9.1.x86_64.rpm /home/builder/fedora-review/1270554-haxe/results/haxe-debuginfo-3.2.0-9.1.x86_64.rpm /home/builder/fedora-review/1270554-haxe/results/haxe-debuginfo-3.2.0-9.1.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 install /home/builder/fedora-review/1270554-haxe/results/haxe-3.2.0-9.1.x86_64.rpm /home/builder/fedora-review/1270554-haxe/results/haxe-debuginfo-3.2.0-9.1.x86_64.rpm /home/builder/fedora-review/1270554-haxe/results/haxe-debuginfo-3.2.0-9.1.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: haxe-3.2.0-9.1.x86_64.rpm
          haxe-debuginfo-3.2.0-9.1.x86_64.rpm
          haxe-3.2.0-9.1.src.rpm
haxe.x86_64: W: spelling-error Summary(en_US) Multi -> Mulch, Mufti
=> Ignore.

haxe.x86_64: W: incoherent-version-in-changelog 3.2.0-1 ['3.2.0-9.1', '3.2.0-9.1']
=> Weird name of the SRPM file.

haxe.x86_64: E: non-standard-executable-perm /usr/bin/haxe 775
=> Easy fix: chmod -m0755 %{buildroot}%{_bindir}/%{name}

haxe.x86_64: W: no-manual-page-for-binary haxelib
haxe.x86_64: W: no-manual-page-for-binary haxe
=> Maybe use help2man or look at other distributions for any templates.

haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/swfParser.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/ilib/ilMetaReader.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/ilib/peReader.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/as3code.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/ilib/peData.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/as3parse.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/png.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/as3hlparse.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/ilib/ilMetaTools.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/extc/extc_stubs.c
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/actionScript.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/javalib/jData.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/swflib/swf.ml
haxe-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/haxe-3.2.0/libs/javalib/jReader.ml
==> Please poke upstream about that.

haxe.src: W: spelling-error Summary(en_US) Multi -> Mulch, Mufti
3 packages and 0 specfiles checked; 15 errors, 5 warnings.




Diff spec file in url and in SRPM
---------------------------------
--- /home/builder/fedora-review/1270554-haxe/srpm/haxe.spec	2015-10-12 20:56:12.023418901 +0200
+++ /home/builder/fedora-review/1270554-haxe/srpm-unpacked/haxe.spec	2015-10-12 16:54:57.000000000 +0200
@@ -4,5 +4,5 @@
 Name:           haxe
 Version:        3.2.0
-Release:        1%{?dist}
+Release:        9.1
 Summary:        Multi-target universal programming language
 


Requires
--------
haxe (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libneko.so.1()(64bit)
    libpthread.so.0()(64bit)
    libz.so.1()(64bit)
    libz.so.1(ZLIB_1.2.0)(64bit)
    nekovm
    rtld(GNU_HASH)

haxe-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
haxe:
    haxe
    haxe(x86-64)

haxe-debuginfo:
    haxe-debuginfo
    haxe-debuginfo(x86-64)



Source checksums
----------------
https://github.com/HaxeFoundation/haxelib/archive/4fefbd17a2d9a98200b621de801018af3896d68a.tar.gz#/haxelib-4fefbd17a2d9a98200b621de801018af3896d68a.tar.gz :
  CHECKSUM(SHA256) this package     : 1b817c520c67840cbfba09cd9b9fd95e34faf9ca8ecfc68a98bc83b9236169e2
  CHECKSUM(SHA256) upstream package : 1b817c520c67840cbfba09cd9b9fd95e34faf9ca8ecfc68a98bc83b9236169e2
https://github.com/HaxeFoundation/haxe/archive/3.2.0.tar.gz#/haxe-3.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : 9953a5ec883b3f691ba4f150416b23d5810c36671a36db8d598e300f5c0bf797
  CHECKSUM(SHA256) upstream package : 9953a5ec883b3f691ba4f150416b23d5810c36671a36db8d598e300f5c0bf797
https://github.com/HaxeFoundation/ocamllibs/archive/7a83e902634e1db204f6e3a48c2439f63d83c141.tar.gz#/ocamllibs-7a83e902634e1db204f6e3a48c2439f63d83c141.tar.gz :
  CHECKSUM(SHA256) this package     : 291504e1b111b1adef001c2511568d8008c0323f993517e774622febeadd6c7b
  CHECKSUM(SHA256) upstream package : 291504e1b111b1adef001c2511568d8008c0323f993517e774622febeadd6c7b


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -v -m fedora-rawhide-x86_64 -b 1270554
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 6 Raphael Groner 2015-10-12 15:32 EDT
Created attachment 1082101 [details]
licensecheck.txt
Comment 7 Upstream Release Monitoring 2015-10-12 15:32:19 EDT
raphgro's scratch build of haxe-3.2.0-9.1.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11418047
Comment 8 Raphael Groner 2015-10-12 15:34:12 EDT
- Maybe execute the tests/ files in %check.
Comment 9 Raphael Groner 2015-10-12 15:51:16 EDT
%prep
%setup -q
cd libs && tar -xf %{SOURCE1} --strip-components=1 && cd ..
cd extra/haxelib_src && tar -xf %{SOURCE2} --strip-components=1 && cd ../..

- Use pushd/popd instead of cd, it logs the current working path changes.
http://www.eriwen.com/bash/pushd-and-popd/
Comment 10 Christopher Meng 2015-10-13 03:43:46 EDT
Reset to original status because he needs a sponsor.
Comment 11 Andy Li 2015-10-22 14:13:49 EDT
I've revised the package as suggested. The updated files:
Spec URL: https://dl.dropboxusercontent.com/u/2661116/fedora/haxe/haxe.spec
SRPM URL: https://dl.dropboxusercontent.com/u/2661116/fedora/haxe/haxe-3.2.1-1.fc24.src.rpm

Summary of changes:
 * Package the latest upstream version (3.2.1).
 * Introduce subpackage, haxe-stdlib, for the Haxe standard library to be installed in /usr/share/haxe/.
 * Fix permission of "haxe".
 * Add license breakdown in spec. Also requested license fix in https://github.com/HaxeFoundation/haxe/issues/4602.
 * Fix srpm-spec mismatched versions. Those were introduced by the openSUSE build service I was using. This time I used my machine to build and uploaded to dropbox instead.
 * Use help2man to generate man pages for haxe and haxelib.
 * Use pushd/popd instead of cd.

Things I'm not sure:
 * I'm not sure about the install error. I've tested with fedora-review, and there is indeed an error saying "Error: cannot install both haxe-debuginfo-3.2.1-1.fc24.x86_64 and haxe-debuginfo-3.2.1-1.fc24.x86_64" but that's totally weird to me. Full log can be found at https://dl.dropboxusercontent.com/u/2661116/fedora/haxe/root.log. I can manually install the rpms without error by `sudo rpm -i *.rpm`.
 * I'm not sure whether I have to add "Requires" to the debuginfo package. I browse around the Internet and couldn't find an example of that.
 * I don't think there is anything that fits into a haxe-devel package. There is no such thing as "to develop software that uses haxe", because haxe itself is a dev tool and it is not designed to be linkable and there is no plug-in system.
 * The remaining "incorrect-fsf-address" are fixed in upstream. They were fixed by the patch in the first version of this package. I haven't included the patch in the revised package.

Thank you and best regards,
Andy
Comment 12 Miroslav Suchý 2015-10-23 05:36:08 EDT
> * I'm not sure whether I have to add "Requires" to the debuginfo package. I browse around the Internet and couldn't find an example of that.

No you do not.

> I'm not sure about the install error.

I do not see this error on my workstation.

All issues addressed (I will not past here the review as it is nearly the same as in #5 sans those addressed issues).

Andy - Any time you have question about some Fedora process feel free to ask me.
I just sponsored you into packager group.

APPROVED.
Comment 13 Fedora Update System 2015-10-23 22:29:36 EDT
haxe-3.2.1-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-146c543280
Comment 14 Fedora Update System 2015-10-26 22:20:10 EDT
haxe-3.2.1-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update haxe'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-146c543280
Comment 15 Fedora Update System 2015-10-31 22:29:08 EDT
haxe-3.2.1-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2015-11-06 11:17:46 EST
haxe-3.2.1-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-b031c6bd08
Comment 17 Fedora Update System 2015-11-08 07:26:45 EST
haxe-3.2.1-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update haxe'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-b031c6bd08
Comment 18 Fedora Update System 2015-11-15 22:22:00 EST
haxe-3.2.1-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.